var gInitialized, gClicked, gLocale, gEditorId, wikiEditTip;

if (typeof(gInitialized) == 'undefined')
	gInitialized = false;

if (typeof(gClicked) == 'undefined')
	gClicked = false;

if (typeof(gLocale) == 'undefined')
	gLocale = 'en';

var checkbox = null;

function initDS_tinyMCE(locale, themedir){
  // Jis change about localization: set gLocale
  if (locale){
  	// AR18899
    gLocale = locale.toLowerCase();
    
    //TinyMCE changed the locale codes for chinese - we need to reassign our
    //locale codes to TinyMCE's new ones...
    if (gLocale == "zh_tw"){
      gLocale = "zh";
    }else if(gLocale == "zh_cn"){
      gLocale = "cn";
    }else if(gLocale == "pt_br"){
      gLocale = "pt";
    }
  }

  if (gInitialized) {
    return;
	}
  
  if(typeof(bUsesXForms) == 'undefined'){
    bUsesXForms = false;
  }
  
  var customcss = themedir+"tinymce.css";
  
  //Bulletin Board WYSIWYG Setup...
  tinyMCE.init({
    mode: "none",
    editor_selector: "wysiwyg_bb",
    entity_encoding: "raw" // All characters will be stored in non-entity form except these XML default entities: &amp; &lt; &gt; &quot;	
  });
  
  
  //Default WYSIWYG Setup...
  tinyMCE.init({
    mode: "textareas",
    editor_selector: "wysiwyg",
    entity_encoding: "raw", // All characters will be stored in non-entity form except these XML default entities: &amp; &lt; &gt; &quot;
    theme: "advanced",
    skin : "o2k7",
    skin_variant : "silver",
    content_css : customcss,
    theme_advanced_buttons1: "bold,italic,underline,strikethrough,forecolor,|,justifyleft,justifycenter,justifyright,bullist,numlist,outdent,indent,undo,redo,|,link,hr,charmap,fontsizeselect,fontselect",                          
    theme_advanced_buttons2: "",
    theme_advanced_buttons3: "",
    theme_advanced_toolbar_location: "top",
    theme_advanced_toolbar_align: "left",
    theme_advanced_statusbar_location: "bottom", // required for resizing
    theme_advanced_resizing: true, // resizing button
    theme_advanced_path: false, // turn off the path text
    fix_list_elements: true,
    plugins: "advimage,advlink,safari,tabfocus",
    relative_urls: false, // assume user input url's are absolute url's
    remove_script_host : false,
    fix_content_duplication: false, // gets rid of the mce_serialization attributes
    language: gLocale,
    tab_focus : ':prev,:next',
    setup: function(ed){
      
      ed.onInit.add(function(ed){
        //only create the toggle checkbox if it doesn't already exist.
        var toggle_cbx = ed.id + "_cbx";
        if (!document.getElementById(toggle_cbx)) {
          createToggleButtons(ed);
        }
      });
    }
  });
  
  
  //Weblog Entry WYSIWYG Setup...
  tinyMCE.init({
    mode: "textareas",
    editor_selector: "wysiwyg_social",
    entity_encoding: "raw", // All characters will be stored in non-entity form except these XML default entities: &amp; &lt; &gt; &quot;
    theme: "advanced",
    skin : "o2k7",
    skin_variant : "silver",
    content_css : customcss,
    theme_advanced_buttons1: "bold, italic, underline, strikethrough, forecolor, backcolor," +
    ", justifyleft, justifycenter, justifyright" +
    ", bullist, numlist, outdent, indent, undo, redo,|" +
    ", link, unlink, anchor, image, charmap, hr, blockquote",                          
    theme_advanced_buttons2: "formatselect,fontselect,fontsizeselect,attribs,styleprops,removeformat,cleanup,code,|,cut,copy,paste,pastetext,pasteword,|,search,replace",
    theme_advanced_buttons3: "tablecontrols,|,visualaid,|,fullscreen",
    theme_advanced_toolbar_location: "top",
    theme_advanced_toolbar_align: "left",
    theme_advanced_statusbar_location: "bottom", // required for resizing
    theme_advanced_resizing: true, // resizing button
    theme_advanced_path: false, // turn off the path text
    remove_linebreaks : false,
    fix_list_elements: true,
    plugins: "fullscreen,style,table,advimage,advlink,safari,tabfocus,xhtmlxtras,searchreplace,paste",
    relative_urls: false, // assume user input url's are absolute url's
    remove_script_host : false,
    fix_content_duplication: false, // gets rid of the mce_serialization attributes
    language: gLocale,
    tab_focus : ':prev,:next',
    theme_advanced_blockformats : "p,h2,h3,h4,h5,h6,pre,div,blockquote,dt,dd,code,samp,address",
    setup: function(ed){
    
      ed.onInit.add(function(ed){
        //only create the toggle checkbox if it doesn't already exist.
        var toggle_cbx = ed.id + "_cbx";
        if (!document.getElementById(toggle_cbx)) {
          createToggleButtons(ed);
          fullScreenSetup(ed);
        }
      });

    }
  });  
   

  //Wiki Page WYSIWYG Setup...
  tinyMCE.init({
    entity_encoding: "raw", // All characters will be stored in non-entity form except these XML default entities: &amp; &lt; &gt; &quot;
    mode: "none",
    theme: "advanced",
    skin : "o2k7",
    skin_variant : "silver",
    content_css : customcss,
    theme_advanced_buttons1: "bold, italic, underline, strikethrough, forecolor, backcolor," +
    ", justifyleft, justifycenter, justifyright" +
    ", bullist, numlist, outdent, indent, undo, redo,|" +
    ", link, unlink, anchor, image, charmap, hr, blockquote",                          
    theme_advanced_buttons2: "formatselect,fontselect,fontsizeselect,attribs,styleprops,removeformat,cleanup,code,|,cut,copy,paste,pastetext,pasteword,|,search,replace",
    theme_advanced_buttons3: "tablecontrols,|,visualaid,|,fullscreen",
    theme_advanced_toolbar_location: "top",
    theme_advanced_toolbar_align: "left",
    theme_advanced_statusbar_location: "bottom", // required for resizing
    theme_advanced_resizing: true, // resizing button
    theme_advanced_path: false, // turn off the path text
    remove_linebreaks : false,
    fix_list_elements: true,
    plugins: "fullscreen,style,table,advimage,advlink,safari,tabfocus,xhtmlxtras,searchreplace,paste",
    relative_urls: false, // assume user input url's are absolute url's
    remove_script_host : false,
    fix_content_duplication: false, // gets rid of the mce_serialization attributes
    language: gLocale,
    tab_focus : ':prev,:next',
    theme_advanced_blockformats : "p,h2,h3,h4,h5,h6,pre,div,blockquote,dt,dd,code,samp,address",
    onpageload: "loadWikiTinymce",
    init_instance_callback : "setupWikiTinymceInstance"
  });  
   
  gInitialized = true;

};



/**
 * loadWikiTinymce
 * loads the wysiwyg editor for wiki edit pages.
 */
function loadWikiTinymce(){
  // Are we on an edit wiki page? Only run if we are, which is determined by if the
  // wiki wysiwyg checkbox is present.
  if(document.getElementById("wysiwyg_wiki_checkbox-value")){
    checkbox = document.getElementById("wysiwyg_wiki_checkbox-value"); 
    if(checkbox.checked == true){
      tinyMCE.execCommand('mceAddControl', false, 'wysiwyg_editor-value');
      wikiEditTip = getElementsByStyleClass('wiki-editing-tips');
    }
  }

}



/**
 * setupWikiTinymceInstance
 * sets up the wiki page wysiwyg instance.
 */
function setupWikiTinymceInstance(){
  var ed = tinymce.activeEditor;
  wikiSetup(ed);
  fullScreenSetup(ed);
}



/**
 * Shows or hides the wiki tips box, and creates an event listener to detect
 * click events on the wysiwyg checkbox to run a function to turn on or off the
 * wiki tips box.
 */
function wikiSetup(ed){
  var inputs = document.getElementsByTagName('input'), 
      editor_id = ed.editorId,
      textarea = document.getElementById(editor_id);

  // First time load: if the checkbox exists, handle the wiki tips.
  if (checkbox != null && checkbox.checked) {
    wikiEditTip.style.display = 'none';   
  } else {
    wikiEditTip.style.display = '';
  }
  
  // remove event listeners if present...
  tinymce.dom.Event.remove(ed.getWin(), 'blur', blur_editor);

  // register the blur event on the textarea so Chiba can update the server.
  var blur_editor = tinyMCE.dom.Event.add(ed.getWin(), "blur", function(e){
    tinyMCE_eventhandler(e, checkbox);
  });
  
}



/**
 * Enables or disables with wysiwyg editor for the wiki description field.
 */
function toggleWikiEditor(){
  
  setTimeout(function(){

    var checkbox = document.getElementById("wysiwyg_wiki_checkbox-value");
    // if current editor is plain text, turn on the wysiwyg editor.
    if (checkbox.checked === true){
      // has tinymce control been added to the wiki wysiwyg textarea yet?
      //-->No! Load it.
      if(!tinymce.activeEditor){ 
        loadWikiTinymce();
      //-->Yes! Move the text over to the editor then.
      }else{
        wikiEditTip.style.display = 'none';
        if(tinymce.isIE){
          //I.E. has to reinitialize everytime it has been put into a hidden div!!!
          tinyMCE.execCommand('mceAddControl', false, 'wysiwyg_editor-value');
        }else{
          tinymce.activeEditor.load();
        }
        
      }
  
    // if the current editor is wysiwyg, Chiba will use the plain textarea.
    }else{
      if(tinymce.isIE){
        //I.E. has to remove and reinitialize everytime it has been put into a hidden div!!!
        tinyMCE.execCommand('mceRemoveControl', false, 'wysiwyg_editor-value');   
      }
      document.getElementById("plain_editor-value").focus();
      wikiEditTip.style.display = '';
    }

  },500);

}




/**
 * EA: TinyMCE event handler glue. Ties the TinyMCE textarea interface into Chiba/Flux
 */
function tinyMCE_eventhandler(evt){
  switch (evt.type) {
		case "blur":
		  window.setTimeout(function(){
        tinyMCE_saveText()
      },0);
			break;
		default:
			break;
	}
	return true;
}



/**
 * tinyMCE_saveText_fullscreen
 * function to have Chiba save the textarea value
 */
function tinyMCE_saveText(){

	var curText = tinymce.activeEditor.getContent();
  
  //if starting with wiki, switching to wysiwyg and back again...

  if(checkbox.checked == true){
    curText = curText.replace(/&nbsp;/gi, " "); //transforms non-breaking spaces into a textbox equivalent...    
    curText = curText.replace(/^<p>&nbsp;<\/p>/gi, "\n"); //transforms paragraphs with a non-breaking space character into line breaks...
    curText = curText.replace(/^<p><br><\/p>/gi, "\n"); //transforms paragraphs with brs into line breaks...
    
    if (!tinymce.isOpera) {
      curText = curText.replace(/<br \/>/gi, "\r");
    }else{
      curText = curText.replace(/<br \/>/gi, "\n");
    }
    if (endsWith(curText, "\n")) {
      curText = curText.substring(0, curText.lastIndexOf("\n"))
    }    
  }

  tinyMCE_setXFormsValue(curText);
}



/**
 * tinyMCE_saveText_fullscreen
 * function to have Chiba save the textarea value
 */
function tinyMCE_saveText_fullscreen(ed, checkbox){
  var curText = tinymce.activeEditor.getContent(),
      id;
  
  //Webkit & Opera have a different editorId value than Firefox & IE!!!!
  if(tinymce.activeEditor.editorId == "mce_fullscreen"){
    id = tinymce.activeEditor.settings.fullscreen_editor_id;
  }else{
    id = tinymce.activeEditor.editorId;
  }

  chiba_id = id.substring(0, id.length - 6);
      
  //dojo.debug("Flux.tinyMCE_setXFormsValue: " + chiba_id + "='" + curText + "'");
  //DWREngine.setOrdered(true);
  //DWREngine.setErrorHandler(handleExceptions);
  var sessionKey = document.getElementById("chibaSessionKey").value;
  Flux.setXFormsValue(updateUI, chiba_id, curText, sessionKey);
  tinyMCE.execCommand('mceFocus', true, id);

}




/**
 * Creates a chiba server update when the fullscreen wysiwyg editor closes.
 * @param {Object} ed - active tinymce editor.
 */
function fullScreenSetup(ed){
  
  var editor_id = ed.editorId,
      fullscreen_btn_id = editor_id + "_fullscreen";
  
  // listen to the click event on the fullscreen button...
  tinyMCE.dom.Event.add(fullscreen_btn_id, "click", function(e){
    // if the editor is in fullscreen mode, run the saveText() function...
    if(ed.editorId == "mce_fullscreen"){
      window.setTimeout(function(){
        tinyMCE_saveText_fullscreen(ed);
      },1);
    }
  });
}





/**
 * tinyMCE_setXFormsValue
 * makes Chiba set the xforms value
 */
function tinyMCE_setXFormsValue(textIn){

  var target, id;
  if (window.event) {
    target = window.event.srcElement;
  }else{
    target = tinymce.activeEditor.getElement();
    if(target.id != "mce_fullscreen"){
      while (target && !_hasClass(target, "value")) {
        target = target.parentNode;
      }
    }
  }
  
  // the original textbox id value is different depending on if we are using
  // the fullscreen mode or not!
  if (target.id == "mce_fullscreen") {
    id = tinymce.activeEditor.settings.fullscreen_editor_id;
  }else{
    id = target.id;
  }
  
  
  //for Chiba, cut off the "-value" portion of the textbox id...
  if (id.substring(id.length - 6, id.length) == "-value"){
    id = id.substring(0, id.length - 6);
  } 
  
  //dojo.debug("Flux.tinyMCE_setXFormsValue: " + id + "='" + textIn + "'");
  //DWREngine.setOrdered(true);
  //DWREngine.setErrorHandler(handleExceptions);
  var sessionKey = document.getElementById("chibaSessionKey").value;
  Flux.setXFormsValue(updateUI, id, textIn, sessionKey);
  
}



/**
 * clickCheckBox
 * click the enable/disable wysiwyg checkbox
 */
function clickCheckBox(evt){
  
  var curEvent = (window.event) ? window.event : evt,
      // get the object of the disable/enable wysiwyg checkbox
      editor_checkbox = curEvent.target || curEvent.srcElement,
      editor_checkbox_str = new String (editor_checkbox.id),
      index = editor_checkbox_str.lastIndexOf('_cbx'),
      // get current editor id
      editor_id = editor_checkbox_str.substring(0, index);
      gEditorId = editor_id;

  // if current editor is wysiwyg, click it to switch back to the original editor
  if (editor_checkbox.checked){
      // add Tiny MCE control
      tinyMCE.execCommand('mceAddControl',false,editor_id); 
      var ed= tinyMCE.get(editor_id);
      tinyMCE.dom.Event.add(ed.getWin(), "blur", function(e){
        tinyMCE_eventhandler(e, ed);
      });
      
      
  // if current editor is wysiwyg, turn in into a plain textarea...
  }else{
      gClicked = true;         
      // remove TinyMCE control
      tinyMCE.execCommand('mceRemoveControl',false,editor_id);
      document.getElementById(editor_id).focus();
      
          
  }
} // clickCheckBox



/**
 * createToggleButtons
 * create the disable-wysiwyg button and enable-wysiwyg button
 * @param inst - the rich text area instance.
 */

function createToggleButtons(inst){
  var editor_id = inst.id,
      d = document,
      w = window.location.href,
      editor = d.getElementById(editor_id),
      editor_ifr = d.getElementById(editor_id+"_ifr"),
      editor_container = inst.editorContainer,
      divElement = d.createElement('div'),
      editor_checkbox = d.createElement('input'),
      checkbox_id = editor_id + "_cbx",
      parentNodeType = editor.parentNode.tagName.toUpperCase();
  
  // create enable/disable wysiwyg checkbox
  tinymce.DOM.addClass(divElement, "wysiwyg_checkbox");
  editor_checkbox.setAttribute("type","checkbox");
  editor_checkbox.setAttribute("id", checkbox_id);
  editor_checkbox.defaultChecked = true;
       
  // create the div element and checkbox text
  if (parentNodeType == 'DIV'){
    // layout for IE and wiki
    if (tinyMCE.isMSIE ||
        w.search(/\/Edit\/WikiPage-\d+/) >= 0 ||
        w.search(/\/ServicesLib\/WikiPage-\d+/) >= 0 ||
        w.search(/\/Add\/Wiki-\d+/) >= 0) {
          // create a label element if parent is 'div'
          labelElement = d.createElement('label');
          divElement.appendChild(labelElement);
    }
  }

  divElement.appendChild(editor_checkbox);
  divElement.appendChild( d.createTextNode( 'wysiwyg' ) );
  
  //$(editor_container).insert({after: divElement});
  tinymce.DOM.insertAfter(divElement, editor_container)
  
  // tabIndex change: set tabindex on editor iframe 
  editor_ifr.setAttribute('tabIndex', '1');
  // register click event with a function.
  editor_checkbox.onclick = clickCheckBox;
  
  if (bUsesXForms === true) {
    tinyMCE.dom.Event.add(inst.getWin(), "blur", function(e){
      tinyMCE_eventhandler(e, inst);
    });
  }

  checkbox = editor_checkbox; //assign new checkbox to the checkbox global variable.

} // createToggleButtons()





/* ----------------- */
/* Utility Functions */
/* ----------------- */

function dump(s, obj){
  var str = s;
  for (var i in obj)
    str += (i + ' => ' + obj[i] + ", ");
  window.confirm("dump: " + str);
}



// get div element by class name
function getElementsByStyleClass (className) {
  var all = document.all ? document.all :  document.getElementsByTagName('div');
  for (var e = 0; e < all.length; e++)
  {
    if (all[e].className == className)
    {
      return all[e];
    }
  }
}


String.prototype.trim = function () {
    return this.replace(/^\s*/, "").replace(/\s*$/, "");
}


function endsWith(str, s){
  var reg = new RegExp(s + "$");
  return reg.test(str);
}






/* Other Functions (Not Used) */


/* example function demonstrating how to completely reload TinyMCE:
function initDS_reloadTinyMCE(bUsesXForms, pageType)
{
	if (!gUseTinyMCE)
		return;

	var dsParams = getDefaultParams(bUsesXForms);
	if (pageType == 'wiki') {
		dsParams.theme_advanced_statusbar_buttons = "wiki, code, fullscreen"; // custom EA enhancement

		if ( (typeof(gInitialized) != 'undefined') && (gInitialized) ) {
			// blow away the previous tinyMCE engine
			tinyMCE = new TinyMCE_Engine();
		}
		tinyMCE.init(dsParams); // replace with our modified status buttons
		gInitialized = true;
	}
}
*/

// a function to convert Wiki syntax to HTML
tinymce.ripWiki = function()
{
	var inst = tinyMCE.selectedInstance;
	var content = inst.getHTML();

  inst.undoRedo.add({content: content});

  // replace \\ with <br>
	content = content.replace(/\\\\/gi, '<br class="newline">');

  // replace **text** with <strong>text</strong>
	content = content.replace(/\*\*(.+)\*\*/gi, "<strong>$1</strong>");
	// replace ~~text~~ with <em>text</em>
	content = content.replace(/~~(.+)~~/gi, "<em>$1</em>");
	// replace --text-- with <del>text</del>
	content = content.replace(/--(.+)--/gi, "<del>$1</del>");

	// extract the wiki page and base DocuShare URL
	var wikiPage, dsWebURL;
	var myURL = window.location.href;
	var wikiIdx = myURL.search(/\/Edit\/WikiPage-/);
	if (wikiIdx >= 0) {
		wikiPage = myURL.substring(wikiIdx+6);
		dsWebURL = myURL.substring(0, wikiIdx+1);
		// somehow need the Wiki Handle...
	}

	// replace [[Document-XX]] with <a>
	content = content.replace(/\[\[(Document\-\d+)\]\]/gi, "<a href=\"" + dsWebURL + "Get/$1\">$1</a>");
	// replace [[WikiPage@Wiki-XX]] with <a>
	content = content.replace(/\[\[(.+)@(Wiki-\d+)\]\]/gi, "<a href=\"" + dsWebURL + "View/$2/$1\">$1</a>");

	// replace {image:Document-XX} with <img>
	content = content.replace(/{image:(Document\-\d+)}/gi, "<img src=\"" + dsWebURL + "Get/$1\" />");

// this one still not working: ?? test this it may be working now
	// replace [[http://address|title]] with <a href="address">title</a>
	content = content.replace(/\[\[(http:\/\/.+)\|(.+)\]\]/gi, "<a href=\"$1\">$2</a>");
	// replace [[http://address]] with <a>
	content = content.replace(/\[\[(http:\/\/.+)\]\]/gi, "<a href=\"$1\">$1</a>");

/* still needs work; getting close
	// replace the different ! - !!!!!! heading levels
	content = content.replace(/(\n!{6})|(^!{6}) (.+)/gi, "<h6>$3</h6>");
	content = content.replace(/(\n!{5})|(^!{5}) (.+)/gi, "<h5>$3</h5>");
	content = content.replace(/(\n!{4})|(^!{4}) (.+)/gi, "<h4>$3</h4>");
	content = content.replace(/(\n!{3})|(^!{3}) (.+)/gi, "<h3>$3</h3>");
	content = content.replace(/(\n!{2})|(^!{2}) (.+)/gi, "<h2>$3</h2>");
	content = content.replace(/(\n!)|(^!) (.+)/gi, "<h1>$3</h1>");
 */

	inst.setHTML(content);
};




