<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<%@ page import="java.io.*" %>
<%@ page import="java.net.URLDecoder" %>
<%@ page import="java.util.*" %>
<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.amber.util.GenericUtil" %>
<%@ page import="com.xerox.docushare.amber.util.MessageDB" %>
<%@ page import="com.xerox.docushare.object.*" %>

<%@ page import="com.xerox.docushare.amber.util.AmberUtility" %>

<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
<% dsrouting.setDSSession(request); 
request.setCharacterEncoding(dsrouting.getCharEncoding());
response.setContentType(dsrouting.getContentType());
boolean btnReadOnly = ((DSSession)request.getAttribute("DSSession")).isReadOnly(); //AR6202+
final DSSession dsSession = (DSSession)request.getAttribute("DSSession");
final java.util.Locale locale = dsSession.getLocale();
DSUser dsUser = (DSUser)dsSession.getLoginPrincipal();
boolean isCPXUser = DSUserLevels.CPX_LEVEL.equals(dsUser.getUserLevel());
String cssFile = isCPXUser?"routing_wizard_cpx.css":"routing_wizard.css";
String user = dsUser.getHandle().toString();
String userName = GenericUtil.getShortName(dsUser, dsSession);
%>

<head>
    <META HTTP-EQUIV="CACHE-CONTROL" CONTENT="NO-CACHE" />
    <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
    <title><%=MessageDB.get("routing_properties_for_document", locale)%></title>
  <%@ include file="ThemeUtil.jsp" %>
  
<%
// DocuShare Base CSS
%>
<link rel="stylesheet" href="<%=request.getContextPath()%>/themes/<%=theme_name%>/routing_wizard.css" type="text/css"></link>
<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare.gif) 0% 0% no-repeat;}</style>
<%
//Market-specific styling for XC
//******************************
if (! ("FX".equals(dsSession.getServerProperty(DSSession.companyBrand)))) {

	// Enterprise Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.ENTERPRISE_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_enterprise.gif) 0% 0% no-repeat;}</style>
	<%
	// Education Edition Licensed Site 
	} else if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	}
//Market-specific styling for FX
//******************************
} else {
	// Education Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	// CPX logo shows up only for CPX users when NOT licensed for the Education Edition  
	} else if (dsSession.getLoginPrincipal().isUserLevel(DSUserLevels.CPX_LEVEL)) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_cpx.gif) 0% 0% no-repeat;}</style>
	<%
	}
}
%>
  
    
    <!-- //dsutils.js has openHelpTextWindow(url) -->
   <script type="text/javascript" src="<%=request.getContextPath()%>/javascript/common/dsutils.js" > </script>

<script language="javascript">
<!--
// JavaScript for document routing functions
<%@include file="document_routing.js" %>

//-->
</script>

<%
final String btnPubThis = "_pubThis";
final String btnPubNew = "_pubNew";
final String btnAddDraft = "_addDraft";
final String btnDelete = "_delete";
String cmd = "";
if(request.getParameter(btnPubThis) != null) cmd = btnPubThis;
if(request.getParameter(btnPubNew) != null) cmd = btnPubNew;
if(request.getParameter(btnAddDraft) != null) cmd = btnAddDraft;
if(request.getParameter(btnDelete) != null) cmd = btnDelete;
System.out.println("cmd = " + cmd);

// handle of base for new version
boolean canPublish = false;
boolean canRevise = false;
String errorMessage = null;
boolean jobRunning = false; //AR4420+
boolean autoMovePreferredVersion = true; //AR6781+

// fetch parameter list to pass on to frame windows
String params = request.getQueryString();
if (params == null)
    params = "";
else
    params = "?" + params;

String doc = request.getParameter("document");
String workFlowJobName = request.getParameter("workFlowJobName");
String taskID = request.getParameter("routingSlipRequestID");
String aboutRecipient = request.getParameter("aboutRecipient");
String baseForNewVersion = request.getParameter("baseForNewVersion");
String rptType = request.getParameter("reportType");
String returnTo = request.getParameter("return");// + "&document=" + doc;
String returnToTag = request.getParameter("returnTag");
if (returnToTag == null) returnToTag = "Top";

String view = request.getParameter("view");
if(view == null) view = "prop_view";
String pageToInsert = view + ".jsp?document=" + doc;

String queryString = request.getQueryString();
System.out.println("\npageToInsert = " + pageToInsert + ", returnTo = " + returnTo);

//#######################################################################
int workFlowJob = 0;
if(workFlowJobName != null) workFlowJob = Integer.parseInt(workFlowJobName);
int tid = 0;
if(taskID != null) tid = Integer.parseInt(taskID);

if(workFlowJob == 0 && tid == 0) {
    out.println("<div id=\"content\">no workFlowJobName and routingSlipRequestID specified!</div>");
    return;
}

DSDocument dsDoc = null;
DSVersion dsVersion = null;
try {
    if (doc == null) {
        throw new IllegalStateException("No document specified.");
    }
    
    DSObject dsObj = dsSession.getObject(new DSHandle(doc));
    if(dsObj instanceof DSDocument){
        dsDoc = (DSDocument)dsObj;
          String baseDraft = null;
          try{ //AR4420 added try for parseInt
            baseDraft = dsrouting.getBaseDraftForWorkflow(Integer.parseInt(workFlowJobName), doc); //AR4862+
          }catch(Exception e) {dsrouting.JSPLog("prop_all parseInt for workFlowJobName "+workFlowJobName+": "+e);}
          
          if(baseDraft != null && baseDraft.startsWith("Version-"))
            dsVersion = (DSVersion)dsSession.getObject(new DSHandle(baseDraft), DSSelectSet.NO_PROPERTIES); //AR13400
        else
            dsVersion = dsDoc.getPreferredVersion(DSSelectSet.NO_PROPERTIES);
    }
    else if (dsObj instanceof DSVersion){
        dsVersion = (DSVersion)dsObj;
        dsDoc = dsVersion.getDocument(DSSelectSet.NO_PROPERTIES);
    }
    else {
        throw new IllegalStateException("Specified object is not a version.");
    }
    
    autoMovePreferredVersion = dsDoc.getAutoMovePreferredVersion() || dsDoc.isDraft(); //AR6781
    String workFlowIDField = workFlowJobName; // AR 4472

    //#######################################################################
    // handle "Publish" form submission from this page
    if(cmd.equals(btnDelete)) {//AR6472+
        try{
            System.out.println("before delete version");
    
            int draftVersionCount = dsDoc.getDraftVersionCount();
            int versionCount = dsDoc.getVersionCount();
            System.out.println("draftVersionCount = "+draftVersionCount+"; versionCount = "+versionCount);
            if(draftVersionCount==1 && versionCount==0) //exponge document
                dsSession.expungeObject(dsDoc.getHandle(), DSSelectSet.NO_PROPERTIES);
            else //exponge version
                dsSession.expungeObject(dsVersion.getHandle(), DSSelectSet.NO_PROPERTIES);                
                out.print("<script language=\"javascript\">parent.close()</script>");
                return;
            }catch(Exception excp) { System.out.println("props_tabbed.jsp delete version: "+excp); }
    }//end AR6472+
    else if(cmd.equals(btnPubThis)) {
        //////////////////////////////////////////////////////////////////////////////////
        //publish_document:
        System.out.println("before publish this version " + dsVersion.getHandle());
    
        if(dsVersion.isDraft()) {
            dsDoc.publish(new DSVersion[] {dsVersion}, null); //AR5057+
            //dsrouting.RecoverDocumentACLs(dsDoc); // Singapore team AR4064
            String setPreferred = request.getParameter("setVersionPreferred");
            //System.out.println("setVersionPreferred = "+ setPreferred);
            if(setPreferred != null && setPreferred.equals("true")){
              try{
                dsDoc.setPreferredVersion(dsVersion);
                System.out.println("after "+dsDoc.getHandle()+".setPreferredVersion("+dsVersion.getHandle()+")");
              }catch(Exception epf) { System.out.println("dsDoc.setPreferredVersion(dsVersion): "+epf); }
            }
        }
        
        // if part of a workflow...
        if (workFlowIDField != null) {
            // determine whether base version can be revised
            baseForNewVersion = dsVersion.getHandle().toExternalForm();
            //baseForNewVersion = workFlowID.routeFrom();
            if (baseForNewVersion != null) {
                // may allow revision if not locked
                if (!dsDoc.isLocked()) {
                    // only allow revision if baseForNewVersion is a document or published version
                    try {
                        DSObject dsBaseObj = dsSession.getObject(new DSHandle(baseForNewVersion), DSSelectSet.NO_PROPERTIES); //AR13400
                        if (dsBaseObj instanceof DSDocument) {
                            canRevise = !((DSDocument)dsBaseObj).isLocked();
                        } else if (dsBaseObj instanceof DSVersion) {
                            DSVersion dsBaseVersion = (DSVersion)dsBaseObj;
                            canRevise = !((DSVersion)dsBaseObj).getDocument(DSSelectSet.NO_PROPERTIES).isLocked() &&!dsBaseVersion.isDraft();
                        }
                        //out.print("<!-- // 167: canRevice =" + canRevise + "-->");
                    } catch (Throwable ex) {
                        // can't revise if object doesn't exist or draft version doesn't have valid workflowID
                        canRevise = false;
                    }
                }
            }
        }

    } else if (workFlowIDField == null) {
        // if not part of a workflow, allow draft doc to be published
        canPublish = dsDoc.isDraft() && !dsDoc.isLocked();
        canRevise = false;
        baseForNewVersion = dsDoc.getHandle().toExternalForm();

        //Singapore team AR4478: recipient can never publish draft
        String retParam = request.getParameter("return");
        if(retParam != null && retParam.indexOf("routingSlipRequestID")!=-1) //it's from request
          canPublish = false;
        //end of Singapore team AR4478                

    } else {
        workFlowJob = Integer.parseInt(workFlowJobName);

        // see if job is currently running
        if (workFlowJob != 0) {
            String jobStatus = dsrouting.getRoutingStatus(workFlowJob);
            jobRunning = dsrouting.isJobRunning(workFlowJob);
        }

        if (jobRunning) {
            canPublish = false; //Singapore team AR4478
            // while job running, allow revision by a recipient if draft version not locked
            canRevise = (aboutRecipient != null) && !dsDoc.isLocked();
            if (canRevise)
                baseForNewVersion = dsVersion.getHandle().toExternalForm();            
        }
        else{//not running
            // after job completion, determine whether base version can be revised and/or published
            //baseForNewVersion = dsVersion.getHandle().toExternalForm(); //AR4420-
            baseForNewVersion = dsDoc.getHandle().toExternalForm(); //AR4420+
            if (baseForNewVersion != null) {
                if(dsrouting.getWorkFlowAction(workFlowJob).indexOf("Review")!=-1){
                    if (!dsDoc.isLocked()) {
                        // only allow revision if baseForNewVersion is a document or published version
                        try {
                            DSObject dsBaseObj = dsSession.getObject(new DSHandle(baseForNewVersion), DSSelectSet.NO_PROPERTIES); //AR13400
                            if (dsBaseObj instanceof DSDocument) {
                                canRevise = !((DSDocument)dsBaseObj).isLocked();
                            } else if (dsBaseObj instanceof DSVersion) {
                                DSVersion dsBaseVersion = (DSVersion)dsBaseObj;
                                canRevise = !((DSVersion)dsBaseObj).getDocument(DSSelectSet.NO_PROPERTIES).isLocked() &&!dsBaseVersion.isDraft();
                            }
                        } catch (Throwable ex) {
                            // can't revise if object doesn't exist or draft version doesn't have valid workflowID
                            canRevise = false;
                        }
                    }
                }else{
                    canRevise = false;
                }

                // can publish if base draft's forVersion points to the draft document
                if (dsDoc.getHandle().toExternalForm().equals(baseForNewVersion)) {
                    canPublish = dsDoc.isDraft() && !dsDoc.isLocked();
                } else {
                    // can also publish if there is only one routing slip for this document
                    canPublish =    dsDoc.isDraft()
                                 && !dsDoc.isLocked()
                                 && (dsrouting.getWorkFlowJobsForDocument(dsDoc.getHandle().toExternalForm()).length <= 1);

                }
                //Singapore team AR4478: recipient can never publish draft
                String retParam = request.getParameter("return");
                if(retParam != null && retParam.indexOf("routingSlipRequestID")!=-1) //it's from request
                  canPublish = false;
                //end of Singapore team AR4478                
            }
        }
    }
} catch (Exception ex) {
    ex.printStackTrace(new PrintWriter(out));  // TEMPORARY (PJG): DEBUG ONLY
    errorMessage = ex.getMessage() + ". Please contact DocuShare customer support";
}

if (errorMessage != null) {
%>
</HEAD>
<script language="javascript">
<!--
    writeError(document, "<%= dsrouting.quotcode(userName) %>", "Internal Error", "<%= dsrouting.quotcode(errorMessage) %>"); //AR6141+
//-->
</script>
</html>
<%
    return;
}

//#######################################################################
boolean isOwner = false;
try{ isOwner = user.equals(dsrouting.getWorkFlowOwner(workFlowJob)); //AR13367+
}catch(Exception eOwner) {}

boolean disapproved = false;
try{ disapproved = dsrouting.getRoutingStatus(workFlowJob).indexOf("Disapproved")!=-1;
}catch(Exception e1) {}

//9778+:
boolean isRecord = false;
try{ isRecord = dsDoc.getIsRecord();
}catch(Exception e){
  System.out.println("prop_all.jsp check dsDoc.getIsRecord(): "+ e); }
//end AR9778+

//AR6949+:
try{
  if(aboutRecipient != null){
    btnReadOnly = btnReadOnly || !dsDoc.checkPermissions(dsUser, DSPermission.WriteLinked);
  }
}catch(Exception e){
  System.out.println("prop_all.jsp check Write permission: "+ e); }
//end AR6949+

//AR15251+:
try{
  if(DSUserLevels.MINIMUM_LEVEL.equals(dsUser.getUserLevel())){
    btnReadOnly = true;
  }
}catch(Exception e){
  System.out.println("prop_all.jsp check user level: "+ e); }
//end AR15251+

//#######################################################################
//button show logic:
boolean showPubThis = true;
boolean showPubNew = true;
boolean showAddDraft = true;
boolean showDelete = true;

if(btnReadOnly) {
    showPubThis = false;
    showPubNew = false;
    showAddDraft = false;
    showDelete = false;
}

if(!cmd.equals("") || request.getParameter("submit") != null) {//form submision
    showPubThis = false;
    showPubNew = false;
    showDelete = false;
    showAddDraft = false;
}

if(rptType != null) {//Report: owner open himself, owner open recipient, recipient open from routing tab
    showAddDraft = false;
}

if(dsrouting.isJobRunning(workFlowJob)) {//job running cannot publish
    showPubThis = false;
    showPubNew = false;
}else {//job done cannot add draft
    showAddDraft = false; 
}

if(dsDoc.isLocked() || isRecord) {
    showPubNew = false;
    showAddDraft = false;
}

if(aboutRecipient != null) {
    if(rptType == null || !rptType.equals("ForReviewReport")) {//owner publish reviewer draft
        showPubThis = false;
    }
    showPubNew = false;
    showDelete = false;
}

if(returnToTag == null)
    ;
//AR21413 replaced "routing_unpublished=Unpublished" with "routing_unpublished_document=Unpublished Document":
else if(returnToTag.startsWith(MessageDB.get("routing_unpublished_document", locale))) {
    showAddDraft = false;
    showPubThis = true;
}
else if(!returnToTag.endsWith(MessageDB.get("routing_forReviewRequest", locale))) {
    showAddDraft = false;
}

if(!dsVersion.isDraft()) {
    showPubThis = false;
    showDelete = false;
}

if(!isOwner) {
    showPubThis = false;
    showDelete = false;
    showPubNew = false;
}

if(disapproved) {
    showPubThis = false;
    showPubNew = false;
}
else {//approved
    showDelete = false;
}

if(taskID != null) {//it's from completion notification
    if(returnTo != null && returnTo.startsWith("OrphanDraftRequest.jsp"))
        System.out.println("taskID != null: show PubThis button only for Orphan Draft Request"); //AR19258
    else
        showPubThis = false;
    showPubNew = false;
}

String buttonURL = "prop_button.jsp?buttons=";
if(showPubThis) buttonURL += btnPubThis;
if(showPubNew) buttonURL += btnPubNew;
if(showAddDraft) buttonURL += btnAddDraft;
if(showDelete) buttonURL += btnDelete;

%>

</head>
<body id="properties">

<div id="header">
    <h1>DocuShare</h1>
    <h2>View Properties for Document</h2>
    <div id="header-wrapper">
        <p><strong><%=MessageDB.get("Username", locale)%>:</strong> <%= GenericUtil.getShortName(dsUser, dsSession) %></p>
    </div>
</div>

<div class="breadcrumbs">
<%
    /*
    String title = MessageDB.get("routing_properties_for_title", new Object[]{ docTitle }, locale);
    if (canPublish)
        title += " (" + MessageDB.get("routing_unpublished", locale) + ")"; //Unpublished
    */
String versionFileName = dsVersion.getPreferredRendition(DSSelectSet.NO_PROPERTIES).getContentElements()[0].getPreferredFileName();
versionFileName = dsrouting.removePoisonChars(versionFileName);
String docTitle = (dsDoc == null) ? "" : dsDoc.getTitle();
docTitle = dsrouting.quotcode(docTitle);
String prop_categories_properties = MessageDB.get("docushare.amber.property_categories.properties", locale);
%>
<%= MessageDB.get("docushare.amber.property_categories.location", locale)%>: <a href='<%= returnTo %>' target='_top'><%= returnToTag %></a>
 &raquo; <a href='<%= request.getContextPath() %>/dsweb/Get/<%= dsVersion.getHandle().toString() %>/<%= versionFileName %>'
  target='_new'><%= AmberUtility.xss_safe_value(docTitle) %></a> <%= prop_categories_properties %>
</div>

<div id="content">
<h2><%=MessageDB.get("routing_properties_for_document", locale)%></h2>
<ul id="propnav">
    <li><a href="prop_all.jsp?view=prop_view&<%= queryString %>"><%=MessageDB.get("routing_tooltip_properties", locale)%></a></li>
    <li><a href="prop_all.jsp?view=prop_routing&<%= queryString %>"><%=MessageDB.get("routing_details", locale)%></a></li>
</ul>

<%
canRevise = showAddDraft || showPubNew;
canPublish = showPubThis || showDelete;
%>
    <form name="routingForm" action="prop_all.jsp" target="_top" method="GET">    
    <!-- Hidden form fields -->
<% for (java.util.Enumeration paramEnum = request.getParameterNames(); paramEnum.hasMoreElements(); ) {
    String name = (String)paramEnum.nextElement();
    String value = request.getParameter(name);
%>
    <input type="hidden" name="<%= name %>" value="<%= value %>">
<% }
%>
    <input type="hidden" name="baseForNewVersion" value="<%= baseForNewVersion %>">

<% 
if(canPublish) {%>
    <input type="hidden" name="publishdocument" />
<%  
    if(!autoMovePreferredVersion) {//AR6781+ %>
    <input type="hidden" name="setVersionPreferred" value="false">
<%  }
}
%>

<!--
    <input type="hidden" name="document" value="<%= doc %>">
    <input type="hidden" name="workFlowJobName" value="<%= workFlowJobName %>">
<%if(taskID != null) {%>
    <input type="hidden" name="routingSlipRequestID" value="<%= taskID %>">
<%}%>
<%if(aboutRecipient != null) {%>
    <input type="hidden" name="aboutRecipient" value="<%= aboutRecipient %>">
<%}%>    
    <input type="hidden" name="return" value="<%= returnTo %>">
    <input type="hidden" name="returnTag" value="<%= returnToTag %>">
-->

<jsp:include page="<%= buttonURL %>"/>
		
<jsp:include page="<%= pageToInsert %>"/>

<jsp:include page="<%= buttonURL %>"/>
    </form>

</div>
</body>
</html>