<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<%@ page import="java.util.*" %>
<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.object.*" %>
<%@ page import="com.xerox.docushare.amber.util.MessageDB" %>
<%@ page import="com.xerox.docushare.amber.util.GenericUtil" %>

<jsp:useBean id="wizardBean" scope="session" class="com.xerox.docushare.routing.WizardBean" />
<jsp:useBean id="browserInfo" scope="session" class="com.xerox.docushare.routing.BrowserInfo">
  <% browserInfo.setUserAgent(request.getHeader("USER-AGENT")); %>
</jsp:useBean>
<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
<%
request.setCharacterEncoding(dsrouting.getCharEncoding());
response.setContentType(dsrouting.getContentType());
boolean btnReadOnly = ((DSSession)request.getAttribute("DSSession")).isReadOnly(); //AR6202+

boolean isNetscape = "Netscape".equals(browserInfo.getProperty("browserType"));
boolean isMozilla = "Mozilla".equals(browserInfo.getProperty("browserType"));	//AR6905

final DSSession dsSession = (DSSession)request.getAttribute("DSSession");
final java.util.Locale locale = dsSession.getLocale();
DSUser dsUser = (DSUser)dsSession.getLoginPrincipal();
boolean isCPXUser = DSUserLevels.CPX_LEVEL.equals(dsUser.getUserLevel());
String cssFile = isCPXUser?"routing_wizard_cpx.css":"routing_wizard.css";
if(wizardBean.getOwner().equals("owner")){
%>
	<script language="javascript">
	<!-- Hide code from non-js browsers
		alert("<%=MessageDB.get("routing_session_timed_out", locale)%>");
	//-->
	</script>
<%
	out.print("\n<script language=\"javascript\">parent.close();</script>");
	return;
}
if(dsUser.isGuestUser()){
    out.print("\n<script language=\"javascript\">parent.close();</script>");
    return;
}
int curStep = wizardBean.setCmd_fromPage(request);
int fromPage = wizardBean.getFromPage();
String Page = MessageDB.get("page", locale);

String ug = wizardBean.UserOrGroup;
String cmd = wizardBean.getCommand();
boolean isSearch = cmd.equals("Search");
boolean isShowAll = cmd.equals("ShowAll");
boolean isShowFavorites = cmd.equals("ShowFavorites");
%>
<TITLE><%=MessageDB.get("routing_wizard_title", new Object[]{"2", ""+curStep}, locale)%></TITLE>
  <%@ include file="ThemeUtil.jsp" %>
  
<%
// DocuShare Base CSS
%>
<link rel="stylesheet" href="<%=request.getContextPath()%>/themes/<%=theme_name%>/routing_wizard.css" type="text/css"></link>
<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare.gif) 0% 0% no-repeat;}</style>
<%
// Market-specific styling for XC
// ******************************
if (! ("FX".equals(dsSession.getServerProperty(DSSession.companyBrand)))) {

   // Enterprise Edition Licensed Site
   if (dsSession.getServer().isLicensed( DSLicenseCodes.ENTERPRISE_EDITION )) {
   %>   
   <style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_enterprise.gif) 0% 0% no-repeat;}</style>
   <%
   // Education Edition Licensed Site 
   } else if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
   %>
   <style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
   <%
   }
// Market-specific styling for FX
// ******************************
} else {
   // Education Edition Licensed Site
   if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
   %>   
	<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
   <%
   // CPX logo shows up only for CPX users when NOT licensed for the Education Edition  
   } else if (dsSession.getLoginPrincipal().isUserLevel(DSUserLevels.CPX_LEVEL)) {
   %>
   <style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_cpx.gif) 0% 0% no-repeat;}</style>
   <%
   }

}
%>
  
<script type="text/javascript" src="<%=request.getContextPath()%>/javascript/common/dsutils.js" > </script>
</head>
<body id="wiz_page2">
<div id="header">
    <h1>DocuShare</h1>
    <h2><%=MessageDB.get("routing_wizard_title", new Object[]{"2", ""+curStep}, locale)%></h2>
    <div id="header-wrapper"><p><strong><%=MessageDB.get("Username", locale)%>:</strong> <%= GenericUtil.getShortName(dsUser, dsSession) %></p></div>
        <ul id="subheader">
        <li class="nav_label"><%=MessageDB.get("routing_wizard_header", new Object[]{curStep, wizardBean.getSteps()},locale)%>:</li>
        <li class="wiz_page1"><%=Page%> 1 &raquo;</li>
        <li class="wiz_page2"><%=Page%> 2 &raquo;</li>
        <li class="wiz_page3"><%=Page%> 3 &raquo;</li>
        <li class="wiz_review"><%=MessageDB.get("routing_wizard_review", locale)%></li>
        </ul>
    </div>
    
    <div id="content">
        <h2><%=MessageDB.get("routing_wzdp2_header", locale)%></h2>
		<p><%=MessageDB.get("routing_wzdp2_desc", locale)%></p>

<form name="fm" method="POST" action="wizard_p3.jsp">
    <input type="hidden" name="cmd" />

    <table class="propstable">
    <tr>
        <td align="right"><a href="javascript:openHelpTextWindow('<%= request.getContextPath()%>/dsweb/PropHelp/show')"
            target="_parent" class="fieldname"><%=MessageDB.get("show_label", locale)%>:</a></td>
        <td>
        <input type=radio name="UserOrGroup" value="User" <%=ug.equals("User")?"checked":""%>> <%=MessageDB.get("Users", locale)%> </input>
        <input type=radio name="UserOrGroup" value="Group" <%=ug.equals("Group")?"checked":""%>> <%=MessageDB.get("Groups", locale)%> </input> 
        <input type=radio name="UserOrGroup" value="Both" <%=ug.equals("Both")?"checked":""%>> <%=MessageDB.get("Both", locale)%> </input>
        </td></tr>
    <tr>
        <td align=right>
        <a href="javascript:openHelpTextWindow('<%= request.getContextPath()%>/dsweb/PropHelp/search_user_group')" target="_parent" class="fieldname">
<%=MessageDB.get("Search_label", locale)%>:</a></td>
        <td><input type=text name="SearchBy" value="<%=wizardBean.SearchBy %>">
        <input type=submit value="<%=MessageDB.get("button.go", locale)%>" onClick="fm.cmd.value='Search'; setRecipients(); fm.action='wizard_p2.jsp';"></td>
    </tr>


    <!-- //AR6987, add Show All and Show Favorites buttons -->
    <tr>
    <td align=right></td>
    <td>
<%
if( DSPermit.YES.equals(dsSession.canDo(DSFeatureCodes.SHOW_ALL)) ) {//AR19135+
%>
    <input type=submit value="<%=MessageDB.get("showAll", locale)%>"
        onClick="fm.cmd.value='ShowAll'; setRecipients(); fm.action='wizard_p2.jsp';">
<%
}%>
    <input type=submit value="<%=MessageDB.get("showFavorites", locale)%>"
        onClick="fm.cmd.value='ShowFavorites'; setRecipients(); fm.action='wizard_p2.jsp';">
    </td>
    </tr>

    <tr><td ALIGN="right" VALIGN="top" nowrap="true">
    <a href="javascript:openHelpTextWindow('<%= request.getContextPath()%>/dsweb/PropHelp/possible_user_group')" target="_parent" class="fieldname">
<%=MessageDB.get("possible_user_group_label", locale)%>:</a></td>
    <td valign=center><select name="lstUG" size=10 multiple="multiple">
<%
//add a blank option first
out.print("  <option selected=\"selected\">" +"\n");
ArrayList aryRc = wizardBean.getRecipients(curStep); //seleted user/groups

// for the first time loading this page, set the "Possible Users/Groups" to be the favorite ones.
if (fromPage == 1)
{
	isShowFavorites = true;
	wizardBean.SearchCmd = "ShowFavorites";
}	

//if(isSearch) {//after click Go
if(isSearch || isShowAll || isShowFavorites) {
  Iterator itrUserGroup = wizardBean.getUserGroupList (aryRc).iterator(); //exclude
  while(itrUserGroup.hasNext()){
    try{
      DSObject obj = (DSObject)itrUserGroup.next();
      String entryName = wizardBean.getFullName(obj);
      out.print("  <option value=\""+ obj.getHandle() +"\">"+ entryName +"\n");
    }catch(Exception e) {
      System.out.println("wizard_p2.jsp loop users: "+ e); 
    }
  }
}
%>  
    </select>
    </td>
</tr>
<tr><td> &nbsp </td><td>
<input type=button value="<%=MessageDB.get("button.add", locale)%> &darr;" onClick="addSelected();" /> 
<input type=button value="<%=MessageDB.get("button.remove", locale)%> &uarr;" onClick="removeSelected();" /></td>
</tr>
<tr><td ALIGN="right" VALIGN="top" nowrap="true">
<a href="javascript:openHelpTextWindow('<%= request.getContextPath()%>/dsweb/PropHelp/selected_user_group')" target="_parent" class="fieldname">
<%=MessageDB.get("selected_user_group_label", locale)%>:</a></td>
<td><select name="lstUGSelected" multiple="multiple" size=8 onchange="checkMultiple();">
<%
Iterator itrRc = aryRc.iterator();
Iterator itrRcName = wizardBean.getRecipientNames(curStep).iterator();
while(itrRc.hasNext()){
  out.print("  <option value=\""+ itrRc.next() +"\">"+ itrRcName.next() +"\n");
}
%>
</select>
</td>
</tr>
<tr><td> &nbsp </td><td>
<input type=button name="moveUpButton" value="<%=MessageDB.get("button.move_up", locale)%> &uarr;" onClick="moveUpSelected();"> 
<input type=button name="moveDownButton" value="<%=MessageDB.get("button.move_down", locale)%> &darr;" onClick="moveDownSelected();">
<input type=button name="expandGroup" value="<%=MessageDB.get("button.expand_group", locale)%>" onClick="expand_group();"></td>
<input type="hidden" name="groupToExpand" value="">
<input type=hidden name="docs" value="<%=wizardBean.getDocumentsString()%>">
</tr>
</table>

<script language="javascript">
<!-- Hide code from non-js browsers
var fm = self.document.forms["fm"];
//alert('docs = '+ fm.docs.value);

<%@include file="wizard_functions.js" %>

function expand_group(){
  var selIdx = fm.lstUGSelected.selectedIndex;
  if(selIdx < 0) {
    alert("<%=MessageDB.get("wzdp2_js_popup_no_sel", locale)%>"); //SDL AR9151
    return;
  }
  var selGrp = fm.lstUGSelected.options[selIdx].value;
  if(selGrp.charAt(0) != "G") {
    alert("<%=MessageDB.get("wzdp2_js_popup_not_group", locale)%>"); //SDL AR9151
    return;
  }

  setRecipients(); //for WizardBean to use
  fm.groupToExpand.value = selGrp;
  fm.cmd.value = 'Expand_Group'; 
  fm.action = 'wizard_p2.jsp';
  fm.submit();
  
  //var props = 'dependent=yes,scrollBars=no,resizable=no,toolbar=no,menubar=no,location=no,directories=no,width=10,height=10';
  //checkaclWindow = window.open("expand_group.jsp", "CheckACL", props);
}

function addEntry(sValue, sText){
  var oOption = document.createElement("OPTION");
  oOption.value=sValue;
  oOption.text=sText;
  //fm.lstUGSelected.add(oOption<%= isNetscape?", null":"" %>);
  fm.lstUGSelected.add(oOption<%= isNetscape || isMozilla?", null":"" %>);	//AR6905
}

function addSelected(){
// now support multiple selection
  
//  var selIdx = fm.lstUG.selectedIndex;
//  if(selIdx < 0) return;
//  var selOpt = fm.lstUG.options[selIdx];
//  addEntry(selOpt.value, selOpt.text);
//  fm.lstUG.remove(selIdx);

  var ind = new Array();
  var index = 0;

  for(var i=0; i<fm.lstUG.length; i++){
  	if(fm.lstUG.options[i].selected && i>0){
  	  //alert("i=" + i);
  	  var selOpt = fm.lstUG.options[i];
  	  addEntry(selOpt.value, selOpt.text);
  	  ind[index++] = i;
  	}
  }
  
  for(var x=0; x<ind.length; x++){
	//alert("ind[x]=" + ind[x]);    	
  	fm.lstUG.remove(ind[x]-x);
  }
  
  
  //reselect the blank entry in the list
  //reselect up list:
  //if(selIdx > fm.lstUG.length - 1)
  //  selIdx = fm.lstUG.length - 1;
  //fm.lstUG.selectedIndex = selIdx;
  fm.lstUG.selectedIndex = 0;
}

function removeSelected(){
  // Get the option array from lstUGSelected.
  // Store the un-selected options index into a temp array "ind"
  
  var selIdx = fm.lstUGSelected.selectedIndex;
  if(selIdx < 0) return;
  var oOptionArray = new Array();
  var ind = new Array();
  var index = 0;

  for(var i=0; i<fm.lstUGSelected.length; i++){
    if(fm.lstUGSelected.options[i].selected && i>=0){
      var selOpt = fm.lstUGSelected.options[i];
      var oOption = document.createElement("OPTION");
      oOption.text=selOpt.text;
      oOption.value=selOpt.value;
      oOptionArray[index]=oOption;
      ind[index] = i;
      index=index+1;
    }
  }
  
  //fm.lstUG.add(oOption<%= isNetscape?", null":"" %>);
  
  // Get the original options in lstUG plus the one removed from lstUGSelected to a temp array first.
  var templstUG = new Array();
  for(var i=0; i<fm.lstUG.length; i++){
  	templstUG[i] = fm.lstUG.options[i];
  }
  
  for (var j = 0; j<oOptionArray.length;j++){
    var options = new Array();
    var oOption = oOptionArray[j];
    var x = 0;
    var find = 0;
    for(var i=0; i<templstUG.length; i++){
    var selOpt = templstUG[i];
      if (find == 1 || (oOption.text.toLowerCase() > selOpt.text.toLowerCase())){
        options[x]=selOpt;
      }else {
        options[x]=oOption;
        if(find == 0) {
          options[++x]=selOpt;
        find = 1;
        }
      }
      x++;
    }
    if(find==0)
       options[x] = oOption;
       
  // Clear the lstUG.
  while(fm.lstUG.length != 0){
    fm.lstUG.remove(0);
  }
  templstUG = options;
  }

  // Add the options from the temp array to lstUG.  
  for(var i=0; i<options.length; i++){
    var oOption = document.createElement("OPTION");
    oOption.text=options[i].text;
    oOption.value=options[i].value;
    //fm.lstUG.add(oOption<%= isNetscape?", null":"" %>);
    fm.lstUG.add(oOption<%= isNetscape||isMozilla?", null":"" %>);	//AR6905
  }
  fm.lstUG.options[0].selected = true;
  
  // Remove the one in lstUSSelected.  
  for(var x=0; x<ind.length; x++){    	
  	fm.lstUGSelected.remove(ind[x]-x);
  }

}

function moveUpSelected(){
  var selIdx = fm.lstUGSelected.selectedIndex;
  if(selIdx < 1) return;
  var selOpt0 = fm.lstUGSelected.options[selIdx - 1];
  var selOpt = fm.lstUGSelected.options[selIdx];
  //switch them and reselect:
  var tmptext  = selOpt0.text;
  var tmpvalue = selOpt0.value;
  selOpt0.text = selOpt.text;
  selOpt0.value = selOpt.value;
  selOpt.text = tmptext;
  selOpt.value = tmpvalue;
  fm.lstUGSelected.selectedIndex = selIdx - 1;
}

function moveDownSelected(){
  var selIdx = fm.lstUGSelected.selectedIndex;
  if(selIdx >= fm.lstUGSelected.length - 1) return;
  var selOpt = fm.lstUGSelected.options[selIdx];
  var selOpt1 = fm.lstUGSelected.options[selIdx + 1];
  //switch them and reselect:
  var tmptext  = selOpt1.text;
  var tmpvalue = selOpt1.value;
  selOpt1.text = selOpt.text;
  selOpt1.value = selOpt.value;
  selOpt.text = tmptext;
  selOpt.value = tmpvalue;
  fm.lstUGSelected.selectedIndex = selIdx + 1;
}

function setRecipients(){
  var rcHandles = "";
  var rcNames = "";
  for(var i=0; i< fm.lstUGSelected.length; i++){
    rcHandles = rcHandles + fm.lstUGSelected.options[i].value + "&";
    rcNames = rcNames + fm.lstUGSelected.options[i].text + "&";
  }
  fm.recipients.value = rcHandles;
  fm.recipientNames.value = rcNames;
}

function checkMultiple(){
  var count = 0;
  for(var i=0; i<fm.lstUGSelected.length; i++){
  	if(fm.lstUGSelected.options[i].selected && i>=0)
  	  count = count+1;
  }
  if (count > 1){
    fm.moveUpButton.disabled = true;
    fm.moveDownButton.disabled = true;
    fm.expandGroup.disabled = true;
  }
  else{
    fm.moveUpButton.disabled = false;
    fm.moveDownButton.disabled = false;
    fm.expandGroup.disabled = false;
  }
  
}
//-->
</script>

<input type="hidden" name="fromPage" value="2">
<input type="hidden" name="recipients" value="">
<input type="hidden" name="recipientNames" value="">

<div id="buttonbar">
<input type="submit" value="&laquo; <%=MessageDB.get("button.back", locale)%>" onClick="fm.cmd.value='Back'; setRecipients(); fm.action='wizard_p1.jsp';">
<input type="submit" value="<%=MessageDB.get("button.next", locale)%> &raquo;" onClick="fm.cmd.value='Next'; setRecipients();
 <%=((wizardBean.getActionOrder(curStep)+"").startsWith("Information")?"fm.action='wizard_p4.jsp';":"")%>">
<input type="submit" value="<%=MessageDB.get("button.done", locale)%>" onClick="fm.cmd.value='Done'; setRecipients(); fm.action='wizard_p4.jsp';">
<input type="button" value="<%=MessageDB.get("button.cancel", locale)%>" onClick="parent.close();">
</div>
</form>
</div>
</body>
</html>