<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<%@ page import="java.util.*" %>
<%@ page import="com.xerox.docushare.*" %>
<%@ page import="com.xerox.docushare.object.DSUser" %>
<%@ page import="com.xerox.docushare.amber.util.MessageDB" %>
<%@ page import="com.xerox.docushare.amber.util.GenericUtil" %>

<%@ page import="com.xerox.docushare.amber.util.AmberUtility" %>

<jsp:useBean id="browserInfo" scope="session" class="com.xerox.docushare.routing.BrowserInfo">
  <% browserInfo.setUserAgent(request.getHeader("USER-AGENT")); %>
</jsp:useBean>
<jsp:useBean id="dsrouting" scope="session" class="com.xerox.docushare.routing.DSRouting" />
<% dsrouting.setDSSession(request); 
request.setCharacterEncoding(dsrouting.getCharEncoding());
response.setContentType(dsrouting.getContentType());
boolean btnReadOnly = ((DSSession)request.getAttribute("DSSession")).isReadOnly(); //AR6202+

final DSSession dsSession = (DSSession)request.getAttribute("DSSession");
final java.util.Locale locale = dsSession.getLocale();
DSUser dsUser = (DSUser)dsSession.getLoginPrincipal();
boolean isCPXUser = DSUserLevels.CPX_LEVEL.equals(dsUser.getUserLevel());
String cssFile = isCPXUser?"routing_wizard_cpx.css":"routing_wizard.css";
if(dsUser.isGuestUser()){
    out.print("\n<script language=\"javascript\">parent.close();</script>");
    return;
}

    String owner = request.getParameter("owner");
    
    //String[0][] are template names; String[1][] are owners, String[2][] are IDs, String[3][] are "public" or "private":
    String[][] templateNames = dsrouting.getWorkFlowTemplateNamesWithOwners(owner); //getWorkFlowTemplateNames

    //AR8672 - Drop down box for saved routing templates not sorted
    if (templateNames[0].length>1) {
      ArrayList sortTempList = new ArrayList();
      for (int i=0; i<templateNames[0].length; i++) {
        if(templateNames.length > 3)
            sortTempList.add(new String[]{templateNames[0][i],templateNames[1][i],templateNames[2][i],templateNames[3][i]});
        else
            sortTempList.add(new String[]{templateNames[0][i],templateNames[1][i],templateNames[2][i]});
      }

      Collections.sort(sortTempList, new Comparator() {
        public int compare(Object o1, Object o2) {
          return ((String[])o1)[0].compareToIgnoreCase(((String[])o2)[0]);
        }
      });

      Iterator it = sortTempList.iterator();
      int i=0;
      while (it.hasNext()){
        String[] tmp = (String[])it.next();
        templateNames[0][i] = tmp[0];
        templateNames[1][i] = tmp[1];
        templateNames[2][i] = tmp[2];
        if(templateNames.length > 3)
            templateNames[3][i] = tmp[3];
        i++;
      }
    }
    //AR8672 end
%>

    <title><%=MessageDB.get("button.all_slips", locale)%></title>
  <%@ include file="ThemeUtil.jsp" %>
  
<%
// DocuShare Base CSS
%>
<link rel="stylesheet" href="<%=request.getContextPath()%>/themes/<%=theme_name%>/routing_wizard.css" type="text/css"></link>
<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare.gif) 0% 0% no-repeat;}</style>
<%
//Market-specific styling for XC
//******************************
if (! ("FX".equals(dsSession.getServerProperty(DSSession.companyBrand)))) {

	// Enterprise Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.ENTERPRISE_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_enterprise.gif) 0% 0% no-repeat;}</style>
	<%
	// Education Edition Licensed Site 
	} else if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	}
//Market-specific styling for FX
//******************************
} else {
	// Education Edition Licensed Site
	if (dsSession.getServer().isLicensed( DSLicenseCodes.EDUCATION_EDITION )) {
	%>   
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_education.gif) 0% 0% no-repeat;}</style>
	<%
	// CPX logo shows up only for CPX users when NOT licensed for the Education Edition  
	} else if (dsSession.getLoginPrincipal().isUserLevel(DSUserLevels.CPX_LEVEL)) {
	%>
		<style>#header h1{background:url(<%=request.getContextPath()%>/themes/<%=theme_name%>/images/branding_docushare_cpx.gif) 0% 0% no-repeat;}</style>
	<%
	}
}
%>
  
</head>

<script language="javascript">
<!-- Hide code from non-js browsers
function parentLoad(selTemplateID){
  parent.opener.loadTemplate(selTemplateID.toString());
  window.close();
}
//-->
</script>

  <body class="popup">
    <div id="header">
      <h1>DocuShare</h1>
      <div id="header-wrapper"><p><strong><%=MessageDB.get("Username", locale)%>:</strong> <%= GenericUtil.getShortName(dsUser, dsSession) %></p></div>
    </div>
		<div id="content">
			<h2><%=MessageDB.get("routing_all_saved_slips", locale)%></h2>
			<p><%=MessageDB.get("routing_wizard_saved_slips", locale)%></p>
			
			<h3><%=MessageDB.get("routing_wizard_my_saved_slips", locale)%></h3>
			<ul class="slip_list">
            <% 
            for(int i=0; i<templateNames[0].length; i++){
                boolean priv = templateNames[1][i].equals(owner);
                if(templateNames.length > 3) priv = "private".equals(templateNames[3][i]);
                if(priv)
                    out.println("<li><a href=\"templateNames[2][i]\" onClick=\"parentLoad("+templateNames[2][i]+");\">"+ AmberUtility.xss_safe_value(templateNames[0][i]) +"</a></li>");
            }
            %>
			</ul>
			
			<h3><%=MessageDB.get("routing_wizard_pub_saved_slips", locale)%></h3>
			<ul class="slip_list">
            <% 
            for(int i=0; i<templateNames[0].length; i++){
                boolean priv = templateNames[1][i].equals(owner);
                if(templateNames.length > 3) priv = "private".equals(templateNames[3][i]);
                if(!priv)
                    out.println("<li><a href=\"templateNames[2][i]\" onClick=\"parentLoad("+templateNames[2][i]+");\">"+ AmberUtility.xss_safe_value(templateNames[0][i]) +"</a></li>");
            }
            %>
			</ul>
		</div>
  </body>
</html>    